import ut
import glob
import comtypes.typeinfo
import comtypes.client
comtypes.client.__verbose__ = False

# This test takes quite some time.  It tries to build wrappers for all
# .dll, .tlb, and .ocx in the system directory which contain typelibs.

class Test(ut.TestCase):
    def setUp(self):
        comtypes.client.gen_dir = None

    def tearDown(self):
        comtypes.client.gen_dir = comtypes.client._find_gen_dir()
    
number = 0

def add_test(fname):
    try:
        comtypes.typeinfo.LoadTypeLibEx(fname)
    except WindowsError:
        return
    global number
    def test(self):
        try:
            comtypes.client.GetModule(fname)
        except TypeError, detail:
            # work around the bug that arrays and simple pointer
            # types are not supported as 'out' parameters
            if not str(detail).startswith("'out' parameter"):
                raise

    test.__doc__ = "test GetModule(%r)" % fname
    setattr(Test, "test_%d" % number, test)
    number += 1

for fname in glob.glob(r"c:\windows\system32\*.ocx"):
    add_test(fname)

# MSCALDEV.TLB - UnicodeEncodeError in COM method name
for fname in glob.glob(r"c:\windows\system32\*.tlb"):
    add_test(fname)

# msvbvm60.dll  Ignoring _HiddenInterface which has no base interface
for fname in glob.glob(r"c:\windows\system32\*.dll"):
    add_test(fname)

if __name__ == "__main__":
    ut.main()
