import unittest

def main():
    import sys
    if "-F" in sys.argv:
        sys.argv.remove("-F")
    return unittest.main()

class TextTestRunner(unittest.TextTestRunner):
    def run(self, *args):
        result = super(TextTestRunner, self).run(*args)
        global failures_ignored
        if failures_ignored:
            self.stream.writeln("(%d marked failures ignored)" % failures_ignored)
        return result

unittest.TextTestRunner = TextTestRunner

class TestCase(unittest.TestCase):
    pass

################################################################
# monkeypatching unittest ;-)

# The idea is to mark failing tests by prepending a 'FAIL_' to the
# method.  Example: self.failUnless(..) -> self.FAIL_failUnless(..)
#
# Depending on how the test is run (where to configure it?), the
# meaning of the test methods is then reversed ;-).

# these method names are pairs containing positive and negative tests
NAMES = """
failIf
failUnless
failUnlessEqual
failIfEqual
failUnlessAlmostEqual
failIfAlmostEqual
""".split()

# names which are aliased to the last name in each line.  not yet
# patched, so the FAIL_ magic will not work with them.
ALIASES = """
assertEqual = assertEquals = failUnlessEqual
assertNotEqual = assertNotEquals = failIfEqual
assertAlmostEqual = assertAlmostEquals = failUnlessAlmostEqual
assertNotAlmostEqual = assertNotAlmostEquals = failIfAlmostEqual
assert_ = failUnless
""".strip().splitlines()

# these require special treatment
##failUnlessRaises
##assertRaises = failUnlessRaises

################################################################

failures_ignored = 0

def count(func):
    # return a function which counts reversed tests in a global.
    def doit(*args, **kw):
        global failures_ignored
        failures_ignored += 1
        return func(*args, **kw)
    return doit


import sys
if "-F" in sys.argv:
    sys.argv.remove("-F")
    for i in range(len(NAMES)/2):
        pos, neg = NAMES[2*i], NAMES[2*i+1]
        func = getattr(TestCase, neg)
        setattr(TestCase, "FAIL_%s" % pos, count(func))
        func = getattr(TestCase, pos)
        setattr(TestCase, "FAIL_%s" % neg, count(func))
else:
    for name in NAMES:
        setattr(TestCase, "FAIL_%s" % name,
                getattr(TestCase, name))


##print NAMES
##print ALIASES
