# ctypes client code, using the CSum COM object

from ctypes import *
from ctypes.com import CreateInstance
from ctypes.com.automation import IDispatch
from ctypes.com.connectionpoints import dispinterface_EventReceiver
from sum_gen import CSum, DSumEvents

CLSCTX_INPROC_SERVER = 0x1
CLSCTX_LOCAL_SERVER = 0x4

import sys
if "inproc_server" in sys.argv:
    print "Using CLSCTX_INPROC_SERVER"
    clsctx = CLSCTX_INPROC_SERVER
else:
    print "Using CLSCTX_LOCAL_SERVER"
    clsctx = CLSCTX_LOCAL_SERVER

class SumEvents(dispinterface_EventReceiver):
    _com_interfaces_ = [DSumEvents]
    
    def Added(self, this, a, b, result):
        print "*** Added Event", a, b, result

sum = CreateInstance(CSum, clsctx=clsctx)
result = c_double()
sum.Add(3.14, 3.14, byref(result))
print "Added 3.14 and 3.14, result", result.value

events = SumEvents()
cookie = events.connect(sum)
sum.Add(2.718, 2.718, byref(result))
print "Added 2.718 and 2.718, result", result.value
events.disconnect(cookie)

idisp = pointer(IDispatch())

sum.QueryInterface(byref(IDispatch._iid_), byref(idisp))

count = c_uint()
idisp.GetTypeInfoCount(byref(count))
print "Has Typeinfo?", count.value

del idisp
print "After del idisp"
import gc
gc.collect()

print "After gc.collect()"
